package nl.kallestruik.dtweaks.commands

import co.aikar.commands.BaseCommand
import co.aikar.commands.annotation.CommandAlias
import co.aikar.commands.annotation.Conditions
import co.aikar.commands.annotation.Subcommand
import nl.kallestruik.dtweaks.managers.PocketDimensionManager
import org.bukkit.entity.Player

@CommandAlias("pocketdim")
@Conditions("tweakEnabled:tweak=SpaceTimePockets")
class CommandPocketdim(
    private val pocketDimensionManager: PocketDimensionManager
): BaseCommand() {

    @Subcommand("create")
    fun onCreate(sender: Player) {
        pocketDimensionManager.createPocketForPlayer(sender)
    }

    @Subcommand("tp")
    fun onTp(sender: Player) {
        pocketDimensionManager.teleportPlayerIntoPocket(sender, sender.uniqueId)
    }
}