package nl.kallestruik.dtweaks.fakeplayer

import com.mojang.serialization.DataResult
import com.mojang.serialization.Dynamic
import io.netty.buffer.Unpooled
import net.minecraft.server.v1_16_R3.*
import nl.kallestruik.dtweaks.DTweaks
import org.apache.logging.log4j.Logger
import org.bukkit.Bukkit
import org.bukkit.craftbukkit.v1_16_R3.CraftWorld
import org.bukkit.craftbukkit.v1_16_R3.util.CraftChatMessage
import org.bukkit.entity.Player
import org.spigotmc.event.player.PlayerSpawnLocationEvent
import java.util.*

object FakePlayerList {
    fun a(playerList: PlayerList, networkManager: NetworkManager, entityPlayer: EntityPlayer) {
        // Setup what are normally class level variables
        val server = DTweaks.reflectionUtil.getValueFromField(playerList, "server") as MinecraftServer
        val LOGGER = DTweaks.reflectionUtil.getValueFromField(playerList, "LOGGER") as Logger

        val gameProfile = entityPlayer.profile
        val userCache = server.userCache
        val oldGameProfile = userCache.getProfile(gameProfile.id)
        var oldName = if (oldGameProfile == null) gameProfile.name else oldGameProfile.name

        userCache.a(gameProfile)
        val playerData = playerList.a(entityPlayer)
        if (playerData != null && playerData.hasKey("bukkit")) {
            val bukkit = playerData.getCompound("bukkit")
            oldName = if (bukkit.hasKeyOfType("lastKnownName", 8)) bukkit.getString("lastKnownName") else oldName
        }
        val worldKey: ResourceKey<World> = if (playerData != null) {
            val dataResult: DataResult<ResourceKey<World>> = DimensionManager.a(
                Dynamic(
                    DynamicOpsNBT.a,
                    playerData["Dimension"]
                )
            )
            dataResult.resultOrPartial { o -> LOGGER.error(o) }
                .orElse(World.OVERWORLD) as ResourceKey<World>
        } else {
            World.OVERWORLD
        }
        var worldServer = server.getWorldServer(worldKey) ?: server.E()

        entityPlayer.spawnIn(worldServer)
        entityPlayer.playerInteractManager.a(entityPlayer.world as WorldServer)
        var s1 = "local"
        if (networkManager.getSocketAddress() != null) {
            s1 = networkManager.getSocketAddress().toString()
        }
        val bukkitPlayer: Player = entityPlayer.bukkitEntity
        val ev = PlayerSpawnLocationEvent(bukkitPlayer, bukkitPlayer.location)
        Bukkit.getPluginManager().callEvent(ev)
        val loc = ev.spawnLocation
        worldServer = (loc.world as CraftWorld).handle
        entityPlayer.spawnIn(worldServer)
        entityPlayer.playerInteractManager.a(entityPlayer.world as WorldServer)
        entityPlayer.setPosition(loc.x, loc.y, loc.z)

        //entityplayer.setYawPitch(loc.getYaw(), loc.getPitch());
        try {
            val setYawPitch = Entity::class.java.getDeclaredMethod(
                "setYawPitch",
                Float::class.javaPrimitiveType,
                Float::class.javaPrimitiveType
            )
            setYawPitch.isAccessible = true
            setYawPitch.invoke(entityPlayer, loc.yaw, loc.pitch)
        } catch (e: Exception) {
            e.printStackTrace()
        }
        val worldData = worldServer.getWorldData()

        //playerList.a(entityplayer, (EntityPlayer)null, worldserver1);
        try {
            val a = PlayerList::class.java.getDeclaredMethod(
                "a",
                EntityPlayer::class.java,
                EntityPlayer::class.java,
                WorldServer::class.java
            )
            a.isAccessible = true
            a.invoke(playerList, entityPlayer, null, worldServer)
        } catch (e: Exception) {
            e.printStackTrace()
        }

        //PlayerConnection playerconnection = new PlayerConnection(server, networkmanager, entityplayer);
        val playerConnection: PlayerConnection =
            (entityPlayer as? FakePlayer)?.let { FakePlayerConnection(server, networkManager, it) }
            ?: PlayerConnection(server, networkManager, entityPlayer)
        val gameRules = worldServer.gameRules
        val doImmediateRespawn = gameRules.getBoolean(GameRules.DO_IMMEDIATE_RESPAWN)
        val reducedDebugInfo = gameRules.getBoolean(GameRules.REDUCED_DEBUG_INFO)
        try {
            playerConnection.sendPacket(
                PacketPlayOutLogin(
                    entityPlayer.id,
                    entityPlayer.playerInteractManager.gameMode,
                    entityPlayer.playerInteractManager.c(),
                    BiomeManager.a(
                        worldServer.seed
                    ),
                    worldData.isHardcore,
                    server.F(),
                    DTweaks.reflectionUtil.getValueFromField(playerList, "s") as IRegistryCustom.Dimension,
                    worldServer.dimensionManager,
                    worldServer.dimensionKey,
                    playerList.maxPlayers,
                    worldServer.spigotConfig.viewDistance,
                    reducedDebugInfo,
                    !doImmediateRespawn,
                    worldServer.isDebugWorld,
                    worldServer.isFlatWorld
                )
            )
        } catch (e: Exception) {
            e.printStackTrace()
        }
        entityPlayer.bukkitEntity.sendSupportedChannels()
        playerConnection.sendPacket(
            PacketPlayOutCustomPayload(
                PacketPlayOutCustomPayload.a,
                PacketDataSerializer(Unpooled.buffer()).a(playerList.server.serverModName)
            )
        )
        playerConnection.sendPacket(PacketPlayOutServerDifficulty(worldData.difficulty, worldData.isDifficultyLocked))
        playerConnection.sendPacket(PacketPlayOutAbilities(entityPlayer.abilities))
        playerConnection.sendPacket(PacketPlayOutHeldItemSlot(entityPlayer.inventory.itemInHandIndex))
        playerConnection.sendPacket(PacketPlayOutRecipeUpdate(server.craftingManager.b()))
        playerConnection.sendPacket(PacketPlayOutTags(server.tagRegistry))
        playerList.d(entityPlayer)
        entityPlayer.statisticManager.c()
        entityPlayer.recipeBook.a(entityPlayer)
        playerList.sendScoreboard(worldServer.scoreboard, entityPlayer)
        server.invalidatePingSample()
        val chatMessage = if (entityPlayer.profile.name.equals(oldName, ignoreCase = true)) {
            ChatMessage("multiplayer.player.joined", entityPlayer.scoreboardDisplayName)
        } else {
            ChatMessage("multiplayer.player.joined.renamed", entityPlayer.scoreboardDisplayName, oldName)
        }
        chatMessage.a(EnumChatFormat.YELLOW)
        var joinMessage = CraftChatMessage.fromComponent(chatMessage)
        playerConnection.a(
            entityPlayer.locX(),
            entityPlayer.locY(),
            entityPlayer.locZ(),
            entityPlayer.yaw,
            entityPlayer.pitch
        )
        playerList.players.add(entityPlayer)

        //playerList.playersByName.put(entityplayer.getName().toLowerCase(Locale.ROOT), entityplayer);
        val playersByName = DTweaks.reflectionUtil.getValueFromField(playerList, "playersByName") as HashMap<String, EntityPlayer>
        playersByName[entityPlayer.name.toLowerCase(Locale.ROOT)] = entityPlayer

        //playerList.j.put(entityplayer.getUniqueID(), entityplayer);
        val playersByUUID = DTweaks.reflectionUtil.getValueFromField(playerList, "j") as HashMap<UUID, EntityPlayer>
        playersByUUID[entityPlayer.uniqueID] = entityPlayer

        if (entityPlayer.playerConnection.networkManager.isConnected) {
            var i: Int
            if (joinMessage != null && joinMessage.isNotEmpty()) {
                var var27: Array<IChatBaseComponent?>
                val var26 = CraftChatMessage.fromString(joinMessage).also { var27 = it }.size
                i = 0
                while (i < var26) {
                    val line = var27[i]
                    server.playerList.sendAll(PacketPlayOutChat(line, ChatMessageType.SYSTEM, SystemUtils.b))
                    ++i
                }
            }
            val packet = PacketPlayOutPlayerInfo(PacketPlayOutPlayerInfo.EnumPlayerInfoAction.ADD_PLAYER, entityPlayer)
            for (player in playerList.players) {
                if (player.bukkitEntity.canSee(entityPlayer.bukkitEntity)) {
                    player.playerConnection.sendPacket(packet)
                }
                if (entityPlayer.bukkitEntity.canSee(player.bukkitEntity)) {
                    entityPlayer.playerConnection.sendPacket(
                        PacketPlayOutPlayerInfo(
                            PacketPlayOutPlayerInfo.EnumPlayerInfoAction.ADD_PLAYER,
                            player
                        )
                    )
                }
            }
            entityPlayer.sentListPacket = true
            entityPlayer.playerConnection.sendPacket(
                PacketPlayOutEntityMetadata(
                    entityPlayer.id,
                    DTweaks.reflectionUtil.getValueFromField(entityPlayer, "datawatcher") as DataWatcher, true
                )
            )

            if (entityPlayer.world === worldServer && !worldServer.getPlayers().contains(entityPlayer)) {
                worldServer.addPlayerJoin(entityPlayer)
                server.bossBattleCustomData.a(entityPlayer)
            }

            worldServer = entityPlayer.worldServer
            playerList.a(entityPlayer, worldServer)
            if (server.resourcePack.isNotEmpty()) {
                entityPlayer.setResourcePack(server.resourcePack, server.resourcePackHash)
            }

            for (mobEffect in entityPlayer.getEffects()) {
                playerConnection.sendPacket(PacketPlayOutEntityEffect(entityPlayer.id, mobEffect))
            }

            if (playerData != null && playerData.hasKeyOfType("RootVehicle", 10)) {
                val rootVehicleData = playerData.getCompound("RootVehicle")
                val entity = EntityTypes.a(
                    rootVehicleData.getCompound("Entity"), worldServer
                ) { entity1x: Entity? ->
                    if (!worldServer.addEntitySerialized(entity1x)
                    ) null else entity1x
                }
                if (entity != null) {
                    val uuid: UUID? = if (rootVehicleData.b("Attach")) {
                        rootVehicleData.a("Attach")
                    } else {
                        null
                    }
                    if (entity.uniqueID == uuid) {
                        entityPlayer.a(entity, true)
                    } else {
                        for (passenger in entity.allPassengers) {
                            if (passenger.uniqueID == uuid) {
                                entityPlayer.a(passenger, true)
                                break
                            }
                        }
                    }
                    if (!entityPlayer.isPassenger) {
                        LOGGER.warn("Couldn't reattach entity to player")
                        worldServer.removeEntity(entity)
                        for (passenger in entity.allPassengers) {
                            worldServer.removeEntity(passenger)
                        }
                    }
                }
            }
            entityPlayer.syncInventory()
            LOGGER.info(
                "{}[{}] logged in with entity id {} at ([{}]{}, {}, {})",
                entityPlayer.getDisplayName().string,
                s1,
                entityPlayer.id,
                worldServer?.worldDataServer?.name,
                entityPlayer.locX(),
                entityPlayer.locY(),
                entityPlayer.locZ()
            )
        }
    }
}