package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.RecipeChoice
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class RedyeTerracotta(
    private val plugin: JavaPlugin
): ITweak {
    private val blackRecipeKey = NamespacedKey(plugin, "black_terracotta")
    private val blueRecipeKey = NamespacedKey(plugin, "blue_terracotta")
    private val brownRecipeKey = NamespacedKey(plugin, "brown_terracotta")
    private val cyanRecipeKey = NamespacedKey(plugin, "cyan_terracotta")
    private val blueRecipeKey = NamespacedKey(plugin, "blue_terracotta")
    private val blueRecipeKey = NamespacedKey(plugin, "blue_terracotta")

    private val allTerracotta = RecipeChoice.MaterialChoice(Material.TERRACOTTA, Material.BLACK_TERRACOTTA,
        Material.BLUE_TERRACOTTA, Material.BROWN_TERRACOTTA, Material.CYAN_TERRACOTTA, Material.GRAY_TERRACOTTA,
        Material.GREEN_TERRACOTTA, Material.LIGHT_BLUE_TERRACOTTA,
        Material.LIGHT_GRAY_TERRACOTTA, Material.LIME_TERRACOTTA, Material.MAGENTA_TERRACOTTA,
        Material.ORANGE_TERRACOTTA, Material.PINK_TERRACOTTA, Material.PURPLE_TERRACOTTA, Material.RED_TERRACOTTA,
        Material.WHITE_TERRACOTTA, Material.YELLOW_TERRACOTTA)

    override fun getIdentifier(): String = "RedyeTerracotta"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        addRecipe(blackRecipeKey, Material.BLACK_TERRACOTTA, Material.BLACK_DYE)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(blackRecipeKey)
    }

    private fun addRecipe(key: NamespacedKey, output: Material, dye: Material) {
        val recipe = ShapedRecipe(key, ItemStack(output))
        recipe.shape("TTT", "TDT", "TTT")
        recipe.setIngredient('T', allTerracotta)
        recipe.setIngredient('D', dye)

        plugin.server.addRecipe(recipe)
    }
}